/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation;

import edu.kit.ipd.descartes.core.Entity;

import edu.kit.ipd.descartes.perfdatarepo.Impact;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Weighted Tactic</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getUsedTactic <em>Used Tactic</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getCurrentWeight <em>Current Weight</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getDefaultWeight <em>Default Weight</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getLastImpact <em>Last Impact</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getParentStrategy <em>Parent Strategy</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#getWeightedTactic()
 * @model
 * @generated
 */
public interface WeightedTactic extends Entity {
    /**
	 * Returns the value of the '<em><b>Used Tactic</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Used Tactic</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Used Tactic</em>' reference.
	 * @see #setUsedTactic(Tactic)
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#getWeightedTactic_UsedTactic()
	 * @model required="true" ordered="false"
	 * @generated
	 */
    Tactic getUsedTactic();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getUsedTactic <em>Used Tactic</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Used Tactic</em>' reference.
	 * @see #getUsedTactic()
	 * @generated
	 */
    void setUsedTactic(Tactic value);

    /**
	 * Returns the value of the '<em><b>Current Weight</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Current Weight</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Current Weight</em>' attribute.
	 * @see #setCurrentWeight(double)
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#getWeightedTactic_CurrentWeight()
	 * @model required="true" ordered="false"
	 * @generated
	 */
    double getCurrentWeight();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getCurrentWeight <em>Current Weight</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Current Weight</em>' attribute.
	 * @see #getCurrentWeight()
	 * @generated
	 */
    void setCurrentWeight(double value);

    /**
	 * Returns the value of the '<em><b>Default Weight</b></em>' attribute.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Default Weight</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Weight</em>' attribute.
	 * @see #setDefaultWeight(double)
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#getWeightedTactic_DefaultWeight()
	 * @model required="true" ordered="false"
	 * @generated
	 */
    double getDefaultWeight();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getDefaultWeight <em>Default Weight</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Weight</em>' attribute.
	 * @see #getDefaultWeight()
	 * @generated
	 */
    void setDefaultWeight(double value);

    /**
	 * Returns the value of the '<em><b>Last Impact</b></em>' reference.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Last Impact</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Last Impact</em>' reference.
	 * @see #setLastImpact(Impact)
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#getWeightedTactic_LastImpact()
	 * @model ordered="false"
	 * @generated
	 */
    Impact getLastImpact();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getLastImpact <em>Last Impact</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Last Impact</em>' reference.
	 * @see #getLastImpact()
	 * @generated
	 */
    void setLastImpact(Impact value);

    /**
	 * Returns the value of the '<em><b>Parent Strategy</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.adaptation.Strategy#getTactics <em>Tactics</em>}'.
	 * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Parent Strategy</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent Strategy</em>' container reference.
	 * @see #setParentStrategy(Strategy)
	 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage#getWeightedTactic_ParentStrategy()
	 * @see edu.kit.ipd.descartes.mm.adaptation.Strategy#getTactics
	 * @model opposite="tactics" transient="false"
	 * @generated
	 */
    Strategy getParentStrategy();

    /**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.adaptation.WeightedTactic#getParentStrategy <em>Parent Strategy</em>}' container reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent Strategy</em>' container reference.
	 * @see #getParentStrategy()
	 * @generated
	 */
    void setParentStrategy(Strategy value);

} // WeightedTactic
