/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import java.util.Collection;
import java.util.Random;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

import edu.kit.ipd.descartes.core.impl.EntityImpl;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.Event;
import edu.kit.ipd.descartes.mm.adaptation.Objective;
import edu.kit.ipd.descartes.mm.adaptation.Strategy;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;
import edu.kit.ipd.descartes.mm.adaptation.WeightingFunction;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Strategy</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl#getObjective <em>Objective</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl#getTriggeringEvents <em>Triggering Events</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl#getTactics <em>Tactics</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.StrategyImpl#getWeightingFunction <em>Weighting Function</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class StrategyImpl extends EntityImpl implements Strategy {
	/**
	 * The cached value of the '{@link #getObjective() <em>Objective</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjective()
	 * @generated
	 * @ordered
	 */
	protected Objective objective;

	/**
	 * The cached value of the '{@link #getTriggeringEvents() <em>Triggering Events</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggeringEvents()
	 * @generated
	 * @ordered
	 */
	protected Event triggeringEvents;

	/**
	 * The cached value of the '{@link #getTactics() <em>Tactics</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTactics()
	 * @generated
	 * @ordered
	 */
	protected EList<WeightedTactic> tactics;

	/**
	 * The cached value of the '{@link #getWeightingFunction() <em>Weighting Function</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getWeightingFunction()
	 * @generated
	 * @ordered
	 */
	protected WeightingFunction weightingFunction;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StrategyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdaptationPackage.Literals.STRATEGY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Objective getObjective() {
		if (objective != null && objective.eIsProxy()) {
			InternalEObject oldObjective = (InternalEObject)objective;
			objective = (Objective)eResolveProxy(oldObjective);
			if (objective != oldObjective) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.STRATEGY__OBJECTIVE, oldObjective, objective));
			}
		}
		return objective;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Objective basicGetObjective() {
		return objective;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjective(Objective newObjective) {
		Objective oldObjective = objective;
		objective = newObjective;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.STRATEGY__OBJECTIVE, oldObjective, objective));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Event getTriggeringEvents() {
		return triggeringEvents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTriggeringEvents(Event newTriggeringEvents, NotificationChain msgs) {
		Event oldTriggeringEvents = triggeringEvents;
		triggeringEvents = newTriggeringEvents;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.STRATEGY__TRIGGERING_EVENTS, oldTriggeringEvents, newTriggeringEvents);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTriggeringEvents(Event newTriggeringEvents) {
		if (newTriggeringEvents != triggeringEvents) {
			NotificationChain msgs = null;
			if (triggeringEvents != null)
				msgs = ((InternalEObject)triggeringEvents).eInverseRemove(this, AdaptationPackage.EVENT__TRIGGERS, Event.class, msgs);
			if (newTriggeringEvents != null)
				msgs = ((InternalEObject)newTriggeringEvents).eInverseAdd(this, AdaptationPackage.EVENT__TRIGGERS, Event.class, msgs);
			msgs = basicSetTriggeringEvents(newTriggeringEvents, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.STRATEGY__TRIGGERING_EVENTS, newTriggeringEvents, newTriggeringEvents));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<WeightedTactic> getTactics() {
		if (tactics == null) {
			tactics = new EObjectContainmentWithInverseEList<WeightedTactic>(WeightedTactic.class, this, AdaptationPackage.STRATEGY__TACTICS, AdaptationPackage.WEIGHTED_TACTIC__PARENT_STRATEGY);
		}
		return tactics;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WeightingFunction getWeightingFunction() {
		return weightingFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetWeightingFunction(WeightingFunction newWeightingFunction, NotificationChain msgs) {
		WeightingFunction oldWeightingFunction = weightingFunction;
		weightingFunction = newWeightingFunction;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION, oldWeightingFunction, newWeightingFunction);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setWeightingFunction(WeightingFunction newWeightingFunction) {
		if (newWeightingFunction != weightingFunction) {
			NotificationChain msgs = null;
			if (weightingFunction != null)
				msgs = ((InternalEObject)weightingFunction).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION, null, msgs);
			if (newWeightingFunction != null)
				msgs = ((InternalEObject)newWeightingFunction).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION, null, msgs);
			msgs = basicSetWeightingFunction(newWeightingFunction, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION, newWeightingFunction, newWeightingFunction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
    @Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.STRATEGY__TRIGGERING_EVENTS:
				if (triggeringEvents != null)
					msgs = ((InternalEObject)triggeringEvents).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - AdaptationPackage.STRATEGY__TRIGGERING_EVENTS, null, msgs);
				return basicSetTriggeringEvents((Event)otherEnd, msgs);
			case AdaptationPackage.STRATEGY__TACTICS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTactics()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdaptationPackage.STRATEGY__TRIGGERING_EVENTS:
				return basicSetTriggeringEvents(null, msgs);
			case AdaptationPackage.STRATEGY__TACTICS:
				return ((InternalEList<?>)getTactics()).basicRemove(otherEnd, msgs);
			case AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION:
				return basicSetWeightingFunction(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.STRATEGY__OBJECTIVE:
				if (resolve) return getObjective();
				return basicGetObjective();
			case AdaptationPackage.STRATEGY__TRIGGERING_EVENTS:
				return getTriggeringEvents();
			case AdaptationPackage.STRATEGY__TACTICS:
				return getTactics();
			case AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION:
				return getWeightingFunction();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.STRATEGY__OBJECTIVE:
				setObjective((Objective)newValue);
				return;
			case AdaptationPackage.STRATEGY__TRIGGERING_EVENTS:
				setTriggeringEvents((Event)newValue);
				return;
			case AdaptationPackage.STRATEGY__TACTICS:
				getTactics().clear();
				getTactics().addAll((Collection<? extends WeightedTactic>)newValue);
				return;
			case AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION:
				setWeightingFunction((WeightingFunction)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.STRATEGY__OBJECTIVE:
				setObjective((Objective)null);
				return;
			case AdaptationPackage.STRATEGY__TRIGGERING_EVENTS:
				setTriggeringEvents((Event)null);
				return;
			case AdaptationPackage.STRATEGY__TACTICS:
				getTactics().clear();
				return;
			case AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION:
				setWeightingFunction((WeightingFunction)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.STRATEGY__OBJECTIVE:
				return objective != null;
			case AdaptationPackage.STRATEGY__TRIGGERING_EVENTS:
				return triggeringEvents != null;
			case AdaptationPackage.STRATEGY__TACTICS:
				return tactics != null && !tactics.isEmpty();
			case AdaptationPackage.STRATEGY__WEIGHTING_FUNCTION:
				return weightingFunction != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public WeightedTactic getTacticWithHighestWeight() {

		if (tactics.size() == 0)
			return null;
		
		Random generator = new Random();
		WeightedTactic currentTactic = tactics.get(generator.nextInt(tactics.size()));
		for (WeightedTactic t : tactics) {
			if (t.getCurrentWeight() > currentTactic.getCurrentWeight())
				currentTactic = t;
		}
		
		return currentTactic;
	}

} //StrategyImpl
