/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Control Flow Variable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getExplicitDescription <em>Explicit Description</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getControlFlowVariable()
 * @model abstract="true"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore constraints='EnforceExplicitDescriptionWhenExplicitCharacterizationType'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot EnforceExplicitDescriptionWhenExplicitCharacterizationType='\n\t\t\tself.characterization = RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null'"
 * @generated
 */
public interface ControlFlowVariable extends ModelVariable {
	/**
	 * Returns the value of the '<em><b>Characterization</b></em>' attribute.
	 * The literals are from the enumeration {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Characterization</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Characterization</em>' attribute.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @see #setCharacterization(ModelVariableCharacterizationType)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getControlFlowVariable_Characterization()
	 * @model required="true"
	 * @generated
	 */
	ModelVariableCharacterizationType getCharacterization();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getCharacterization <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Characterization</em>' attribute.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType
	 * @see #getCharacterization()
	 * @generated
	 */
	void setCharacterization(ModelVariableCharacterizationType value);

	/**
	 * Returns the value of the '<em><b>Explicit Description</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Explicit Description</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Explicit Description</em>' containment reference.
	 * @see #setExplicitDescription(RandomVariable)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getControlFlowVariable_ExplicitDescription()
	 * @model containment="true"
	 * @generated
	 */
	RandomVariable getExplicitDescription();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ControlFlowVariable#getExplicitDescription <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Explicit Description</em>' containment reference.
	 * @see #getExplicitDescription()
	 * @generated
	 */
	void setExplicitDescription(RandomVariable value);

} // ControlFlowVariable
