/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.util;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage
 * @generated
 */
public class ParameterdependenciesValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final ParameterdependenciesValidator INSTANCE = new ParameterdependenciesValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParameterdependenciesValidator() {
		super();
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return ParameterdependenciesPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case ParameterdependenciesPackage.MODEL_VARIABLE:
				return validateModelVariable((ModelVariable)value, diagnostics, context);
			case ParameterdependenciesPackage.SCOPE_SET:
				return validateScopeSet((ScopeSet)value, diagnostics, context);
			case ParameterdependenciesPackage.SCOPE:
				return validateScope((Scope)value, diagnostics, context);
			case ParameterdependenciesPackage.CONTROL_FLOW_VARIABLE:
				return validateControlFlowVariable((ControlFlowVariable)value, diagnostics, context);
			case ParameterdependenciesPackage.INFLUENCED_VARIABLE_REFERENCE:
				return validateInfluencedVariableReference((InfluencedVariableReference)value, diagnostics, context);
			case ParameterdependenciesPackage.INFLUENCING_PARAMETER:
				return validateInfluencingParameter((InfluencingParameter)value, diagnostics, context);
			case ParameterdependenciesPackage.SHADOW_PARAMETER:
				return validateShadowParameter((ShadowParameter)value, diagnostics, context);
			case ParameterdependenciesPackage.RELATIONSHIP:
				return validateRelationship((Relationship)value, diagnostics, context);
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP:
				return validateDependencyRelationship((DependencyRelationship)value, diagnostics, context);
			case ParameterdependenciesPackage.DEPENDENCY_PROPAGATION_RELATIONSHIP:
				return validateDependencyPropagationRelationship((DependencyPropagationRelationship)value, diagnostics, context);
			case ParameterdependenciesPackage.COMPONENT_INSTANCE_REFERENCE:
				return validateComponentInstanceReference((ComponentInstanceReference)value, diagnostics, context);
			case ParameterdependenciesPackage.CALL_PARAMETER:
				return validateCallParameter((CallParameter)value, diagnostics, context);
			case ParameterdependenciesPackage.SERVICE_INPUT_PARAMETER:
				return validateServiceInputParameter((ServiceInputParameter)value, diagnostics, context);
			case ParameterdependenciesPackage.EXTERNAL_CALL_RETURN_PARAMETER:
				return validateExternalCallReturnParameter((ExternalCallReturnParameter)value, diagnostics, context);
			case ParameterdependenciesPackage.EXTERNAL_CALL_PARAMETER:
				return validateExternalCallParameter((ExternalCallParameter)value, diagnostics, context);
			case ParameterdependenciesPackage.MODEL_VARIABLE_CHARACTERIZATION_TYPE:
				return validateModelVariableCharacterizationType((ModelVariableCharacterizationType)value, diagnostics, context);
			case ParameterdependenciesPackage.RELATIONSHIP_CHARACTERIZATION_TYPE:
				return validateRelationshipCharacterizationType((RelationshipCharacterizationType)value, diagnostics, context);
			case ParameterdependenciesPackage.PARAMETER_CHARACTERIZATION_TYPE:
				return validateParameterCharacterizationType((ParameterCharacterizationType)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateModelVariable(ModelVariable modelVariable, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(modelVariable, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateScopeSet(ScopeSet scopeSet, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(scopeSet, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateScope(Scope scope, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(scope, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateControlFlowVariable(ControlFlowVariable controlFlowVariable, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(controlFlowVariable, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(controlFlowVariable, diagnostics, context);
		if (result || diagnostics != null) result &= validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(controlFlowVariable, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Control Flow Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String CONTROL_FLOW_VARIABLE__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION = "\n" +
		"\t\t\tself.characterization = RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null";

	/**
	 * Validates the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Control Flow Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(ControlFlowVariable controlFlowVariable, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.CONTROL_FLOW_VARIABLE,
				 controlFlowVariable,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EnforceExplicitDescriptionWhenExplicitCharacterizationType",
				 CONTROL_FLOW_VARIABLE__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInfluencedVariableReference(InfluencedVariableReference influencedVariableReference, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(influencedVariableReference, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(influencedVariableReference, diagnostics, context);
		if (result || diagnostics != null) result &= validateInfluencedVariableReference_ExactlyOneVariableReferenced(influencedVariableReference, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the ExactlyOneVariableReferenced constraint of '<em>Influenced Variable Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String INFLUENCED_VARIABLE_REFERENCE__EXACTLY_ONE_VARIABLE_REFERENCED__EEXPRESSION = "\n" +
		"\t\t\tlet nonnullset : Set(ModelVariable) = Set{controlFlowVariable, resourceDemand, responseTime}->reject(mv|mv = null) \n" +
		"\t\t\tin nonnullset->size() = 1";

	/**
	 * Validates the ExactlyOneVariableReferenced constraint of '<em>Influenced Variable Reference</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInfluencedVariableReference_ExactlyOneVariableReferenced(InfluencedVariableReference influencedVariableReference, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.INFLUENCED_VARIABLE_REFERENCE,
				 influencedVariableReference,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "ExactlyOneVariableReferenced",
				 INFLUENCED_VARIABLE_REFERENCE__EXACTLY_ONE_VARIABLE_REFERENCED__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInfluencingParameter(InfluencingParameter influencingParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(influencingParameter, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateShadowParameter(ShadowParameter shadowParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(shadowParameter, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRelationship(Relationship relationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(relationship, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(relationship, diagnostics, context);
		if (result || diagnostics != null) result &= validateRelationship_EnforceExplicitDescriptionWhenExplicitCharacterizationType(relationship, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String RELATIONSHIP__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION = "\n" +
		"\t\t\tself.characterization = RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null";

	/**
	 * Validates the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRelationship_EnforceExplicitDescriptionWhenExplicitCharacterizationType(Relationship relationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.RELATIONSHIP,
				 relationship,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EnforceExplicitDescriptionWhenExplicitCharacterizationType",
				 RELATIONSHIP__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDependencyRelationship(DependencyRelationship dependencyRelationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(dependencyRelationship, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validateRelationship_EnforceExplicitDescriptionWhenExplicitCharacterizationType(dependencyRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validateDependencyRelationship_DelegationOnlyAllowedWithSingleSource(dependencyRelationship, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the DelegationOnlyAllowedWithSingleSource constraint of '<em>Dependency Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String DEPENDENCY_RELATIONSHIP__DELEGATION_ONLY_ALLOWED_WITH_SINGLE_SOURCE__EEXPRESSION = "\n" +
		"\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies independent->size() = 1";

	/**
	 * Validates the DelegationOnlyAllowedWithSingleSource constraint of '<em>Dependency Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDependencyRelationship_DelegationOnlyAllowedWithSingleSource(DependencyRelationship dependencyRelationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.DEPENDENCY_RELATIONSHIP,
				 dependencyRelationship,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "DelegationOnlyAllowedWithSingleSource",
				 DEPENDENCY_RELATIONSHIP__DELEGATION_ONLY_ALLOWED_WITH_SINGLE_SOURCE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDependencyPropagationRelationship(DependencyPropagationRelationship dependencyPropagationRelationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(dependencyPropagationRelationship, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validateRelationship_EnforceExplicitDescriptionWhenExplicitCharacterizationType(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validateDependencyPropagationRelationship_NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences(dependencyPropagationRelationship, diagnostics, context);
		if (result || diagnostics != null) result &= validateDependencyPropagationRelationship_DelegationOnlyAllowedWithSingleSource(dependencyPropagationRelationship, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences constraint of '<em>Dependency Propagation Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String DEPENDENCY_PROPAGATION_RELATIONSHIP__NUMBER_OF_INDEPENDENT_INFLUENCING_PARAMETERS_EQUAL_TO_INDEPENDENT_COMPONENT_INSTANCE_REFERENCES__EEXPRESSION = "\n" +
		"\t\t\tindependent->size() = independentComponentInstanceReferences->size()";

	/**
	 * Validates the NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences constraint of '<em>Dependency Propagation Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDependencyPropagationRelationship_NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences(DependencyPropagationRelationship dependencyPropagationRelationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP,
				 dependencyPropagationRelationship,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences",
				 DEPENDENCY_PROPAGATION_RELATIONSHIP__NUMBER_OF_INDEPENDENT_INFLUENCING_PARAMETERS_EQUAL_TO_INDEPENDENT_COMPONENT_INSTANCE_REFERENCES__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the DelegationOnlyAllowedWithSingleSource constraint of '<em>Dependency Propagation Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String DEPENDENCY_PROPAGATION_RELATIONSHIP__DELEGATION_ONLY_ALLOWED_WITH_SINGLE_SOURCE__EEXPRESSION = "\n" +
		"\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies independent->size() = 1";

	/**
	 * Validates the DelegationOnlyAllowedWithSingleSource constraint of '<em>Dependency Propagation Relationship</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateDependencyPropagationRelationship_DelegationOnlyAllowedWithSingleSource(DependencyPropagationRelationship dependencyPropagationRelationship, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.DEPENDENCY_PROPAGATION_RELATIONSHIP,
				 dependencyPropagationRelationship,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "DelegationOnlyAllowedWithSingleSource",
				 DEPENDENCY_PROPAGATION_RELATIONSHIP__DELEGATION_ONLY_ALLOWED_WITH_SINGLE_SOURCE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComponentInstanceReference(ComponentInstanceReference componentInstanceReference, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(componentInstanceReference, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCallParameter(CallParameter callParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(callParameter, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(callParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateCallParameter_EitherParameterOrReturnTypeOfSignatureReferenced(callParameter, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EitherParameterOrReturnTypeOfSignatureReferenced constraint of '<em>Call Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String CALL_PARAMETER__EITHER_PARAMETER_OR_RETURN_TYPE_OF_SIGNATURE_REFERENCED__EEXPRESSION = "\n" +
		"\t\t\t(self.parameter.oclIsUndefined() implies (not self.returnType.oclIsUndefined() and self.signature.returnType = self.returnType)) and\n" +
		"\t\t\t(self.returnType.oclIsUndefined() implies (not self.parameter.oclIsUndefined() and self.signature.parameters->includes(self.parameter)))";

	/**
	 * Validates the EitherParameterOrReturnTypeOfSignatureReferenced constraint of '<em>Call Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCallParameter_EitherParameterOrReturnTypeOfSignatureReferenced(CallParameter callParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.CALL_PARAMETER,
				 callParameter,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EitherParameterOrReturnTypeOfSignatureReferenced",
				 CALL_PARAMETER__EITHER_PARAMETER_OR_RETURN_TYPE_OF_SIGNATURE_REFERENCED__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceInputParameter(ServiceInputParameter serviceInputParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(serviceInputParameter, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateCallParameter_EitherParameterOrReturnTypeOfSignatureReferenced(serviceInputParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceInputParameter_MustReferenceInputParameter(serviceInputParameter, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the MustReferenceInputParameter constraint of '<em>Service Input Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String SERVICE_INPUT_PARAMETER__MUST_REFERENCE_INPUT_PARAMETER__EEXPRESSION = "not self.parameter.oclIsUndefined()";

	/**
	 * Validates the MustReferenceInputParameter constraint of '<em>Service Input Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceInputParameter_MustReferenceInputParameter(ServiceInputParameter serviceInputParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.SERVICE_INPUT_PARAMETER,
				 serviceInputParameter,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "MustReferenceInputParameter",
				 SERVICE_INPUT_PARAMETER__MUST_REFERENCE_INPUT_PARAMETER__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallReturnParameter(ExternalCallReturnParameter externalCallReturnParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(externalCallReturnParameter, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateCallParameter_EitherParameterOrReturnTypeOfSignatureReferenced(externalCallReturnParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateExternalCallReturnParameter_MustReferenceReturnParameter(externalCallReturnParameter, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the MustReferenceReturnParameter constraint of '<em>External Call Return Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String EXTERNAL_CALL_RETURN_PARAMETER__MUST_REFERENCE_RETURN_PARAMETER__EEXPRESSION = "not self.returnType.oclIsUndefined()";

	/**
	 * Validates the MustReferenceReturnParameter constraint of '<em>External Call Return Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallReturnParameter_MustReferenceReturnParameter(ExternalCallReturnParameter externalCallReturnParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.EXTERNAL_CALL_RETURN_PARAMETER,
				 externalCallReturnParameter,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "MustReferenceReturnParameter",
				 EXTERNAL_CALL_RETURN_PARAMETER__MUST_REFERENCE_RETURN_PARAMETER__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallParameter(ExternalCallParameter externalCallParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(externalCallParameter, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateCallParameter_EitherParameterOrReturnTypeOfSignatureReferenced(externalCallParameter, diagnostics, context);
		if (result || diagnostics != null) result &= validateExternalCallParameter_MustReferenceInputParameter(externalCallParameter, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the MustReferenceInputParameter constraint of '<em>External Call Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String EXTERNAL_CALL_PARAMETER__MUST_REFERENCE_INPUT_PARAMETER__EEXPRESSION = "not self.parameter.oclIsUndefined()";

	/**
	 * Validates the MustReferenceInputParameter constraint of '<em>External Call Parameter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallParameter_MustReferenceInputParameter(ExternalCallParameter externalCallParameter, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ParameterdependenciesPackage.Literals.EXTERNAL_CALL_PARAMETER,
				 externalCallParameter,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "MustReferenceInputParameter",
				 EXTERNAL_CALL_PARAMETER__MUST_REFERENCE_INPUT_PARAMETER__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateModelVariableCharacterizationType(ModelVariableCharacterizationType modelVariableCharacterizationType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateRelationshipCharacterizationType(RelationshipCharacterizationType relationshipCharacterizationType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return true;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateParameterCharacterizationType(ParameterCharacterizationType parameterCharacterizationType, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return true;
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //ParameterdependenciesValidator
