/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Providing Delegation Connector</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector#getInnerInterfaceProvidingRole <em>Inner Interface Providing Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector#getOuterInterfaceProvidingRole <em>Outer Interface Providing Role</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getProvidingDelegationConnector()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='DelegationConnectorAndTheConnectedComponentMustBePartOfTheSameCompositeStructure ComponentOfAssemblyContextAndInnerRoleProvidingComponentNeedToBeTheSame ProvidingEntityOfOuterInterfaceProvidingRoleMustBeTheSameAsTheParentOfTheProvidedDelegationConnector'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot DelegationConnectorAndTheConnectedComponentMustBePartOfTheSameCompositeStructure='\n\t\tself.parentStructure = self.assemblyContext.parentStructure' ComponentOfAssemblyContextAndInnerRoleProvidingComponentNeedToBeTheSame='\n\t\tself.assemblyContext.encapsulatedComponent = self.innerInterfaceProvidingRole.interfaceProvidingEntity' ProvidingEntityOfOuterInterfaceProvidingRoleMustBeTheSameAsTheParentOfTheProvidedDelegationConnector='\n\t\tself.parentStructure = self.outerInterfaceProvidingRole.interfaceProvidingEntity'"
 * @generated
 */
public interface ProvidingDelegationConnector extends DelegationConnector {
	/**
	 * Returns the value of the '<em><b>Parent Structure</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getProvidingDelegationConnectors <em>Providing Delegation Connectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent Structure</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent Structure</em>' container reference.
	 * @see #setParentStructure(ComposedStructure)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getProvidingDelegationConnector_ParentStructure()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getProvidingDelegationConnectors
	 * @model opposite="providingDelegationConnectors" required="true" transient="false"
	 * @generated
	 */
	ComposedStructure getParentStructure();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector#getParentStructure <em>Parent Structure</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent Structure</em>' container reference.
	 * @see #getParentStructure()
	 * @generated
	 */
	void setParentStructure(ComposedStructure value);

	/**
	 * Returns the value of the '<em><b>Inner Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Inner Interface Providing Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Inner Interface Providing Role</em>' reference.
	 * @see #setInnerInterfaceProvidingRole(InterfaceProvidingRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getProvidingDelegationConnector_InnerInterfaceProvidingRole()
	 * @model required="true"
	 * @generated
	 */
	InterfaceProvidingRole getInnerInterfaceProvidingRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector#getInnerInterfaceProvidingRole <em>Inner Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Inner Interface Providing Role</em>' reference.
	 * @see #getInnerInterfaceProvidingRole()
	 * @generated
	 */
	void setInnerInterfaceProvidingRole(InterfaceProvidingRole value);

	/**
	 * Returns the value of the '<em><b>Outer Interface Providing Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outer Interface Providing Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outer Interface Providing Role</em>' reference.
	 * @see #setOuterInterfaceProvidingRole(InterfaceProvidingRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getProvidingDelegationConnector_OuterInterfaceProvidingRole()
	 * @model required="true"
	 * @generated
	 */
	InterfaceProvidingRole getOuterInterfaceProvidingRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector#getOuterInterfaceProvidingRole <em>Outer Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Outer Interface Providing Role</em>' reference.
	 * @see #getOuterInterfaceProvidingRole()
	 * @generated
	 */
	void setOuterInterfaceProvidingRole(InterfaceProvidingRole value);

} // ProvidingDelegationConnector
