/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.ProvidingDelegationConnector;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Providing Delegation Connector</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl#getInnerInterfaceProvidingRole <em>Inner Interface Providing Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.ProvidingDelegationConnectorImpl#getOuterInterfaceProvidingRole <em>Outer Interface Providing Role</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ProvidingDelegationConnectorImpl extends DelegationConnectorImpl implements ProvidingDelegationConnector {
	/**
	 * The cached value of the '{@link #getInnerInterfaceProvidingRole() <em>Inner Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInnerInterfaceProvidingRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRole innerInterfaceProvidingRole;

	/**
	 * The cached value of the '{@link #getOuterInterfaceProvidingRole() <em>Outer Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOuterInterfaceProvidingRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRole outerInterfaceProvidingRole;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProvidingDelegationConnectorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.PROVIDING_DELEGATION_CONNECTOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposedStructure getParentStructure() {
		if (eContainerFeatureID() != RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE) return null;
		return (ComposedStructure)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetParentStructure(ComposedStructure newParentStructure, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newParentStructure, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentStructure(ComposedStructure newParentStructure) {
		if (newParentStructure != eInternalContainer() || (eContainerFeatureID() != RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE && newParentStructure != null)) {
			if (EcoreUtil.isAncestor(this, newParentStructure))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentStructure != null)
				msgs = ((InternalEObject)newParentStructure).eInverseAdd(this, RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS, ComposedStructure.class, msgs);
			msgs = basicSetParentStructure(newParentStructure, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE, newParentStructure, newParentStructure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole getInnerInterfaceProvidingRole() {
		if (innerInterfaceProvidingRole != null && innerInterfaceProvidingRole.eIsProxy()) {
			InternalEObject oldInnerInterfaceProvidingRole = (InternalEObject)innerInterfaceProvidingRole;
			innerInterfaceProvidingRole = (InterfaceProvidingRole)eResolveProxy(oldInnerInterfaceProvidingRole);
			if (innerInterfaceProvidingRole != oldInnerInterfaceProvidingRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE, oldInnerInterfaceProvidingRole, innerInterfaceProvidingRole));
			}
		}
		return innerInterfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole basicGetInnerInterfaceProvidingRole() {
		return innerInterfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInnerInterfaceProvidingRole(InterfaceProvidingRole newInnerInterfaceProvidingRole) {
		InterfaceProvidingRole oldInnerInterfaceProvidingRole = innerInterfaceProvidingRole;
		innerInterfaceProvidingRole = newInnerInterfaceProvidingRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE, oldInnerInterfaceProvidingRole, innerInterfaceProvidingRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole getOuterInterfaceProvidingRole() {
		if (outerInterfaceProvidingRole != null && outerInterfaceProvidingRole.eIsProxy()) {
			InternalEObject oldOuterInterfaceProvidingRole = (InternalEObject)outerInterfaceProvidingRole;
			outerInterfaceProvidingRole = (InterfaceProvidingRole)eResolveProxy(oldOuterInterfaceProvidingRole);
			if (outerInterfaceProvidingRole != oldOuterInterfaceProvidingRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE, oldOuterInterfaceProvidingRole, outerInterfaceProvidingRole));
			}
		}
		return outerInterfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole basicGetOuterInterfaceProvidingRole() {
		return outerInterfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOuterInterfaceProvidingRole(InterfaceProvidingRole newOuterInterfaceProvidingRole) {
		InterfaceProvidingRole oldOuterInterfaceProvidingRole = outerInterfaceProvidingRole;
		outerInterfaceProvidingRole = newOuterInterfaceProvidingRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE, oldOuterInterfaceProvidingRole, outerInterfaceProvidingRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentStructure((ComposedStructure)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return basicSetParentStructure(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return eInternalContainer().eInverseRemove(this, RepositoryPackage.COMPOSED_STRUCTURE__PROVIDING_DELEGATION_CONNECTORS, ComposedStructure.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return getParentStructure();
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE:
				if (resolve) return getInnerInterfaceProvidingRole();
				return basicGetInnerInterfaceProvidingRole();
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE:
				if (resolve) return getOuterInterfaceProvidingRole();
				return basicGetOuterInterfaceProvidingRole();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)newValue);
				return;
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE:
				setInnerInterfaceProvidingRole((InterfaceProvidingRole)newValue);
				return;
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE:
				setOuterInterfaceProvidingRole((InterfaceProvidingRole)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)null);
				return;
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE:
				setInnerInterfaceProvidingRole((InterfaceProvidingRole)null);
				return;
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE:
				setOuterInterfaceProvidingRole((InterfaceProvidingRole)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__PARENT_STRUCTURE:
				return getParentStructure() != null;
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__INNER_INTERFACE_PROVIDING_ROLE:
				return innerInterfaceProvidingRole != null;
			case RepositoryPackage.PROVIDING_DELEGATION_CONNECTOR__OUTER_INTERFACE_PROVIDING_ROLE:
				return outerInterfaceProvidingRole != null;
		}
		return super.eIsSet(featureID);
	}

} //ProvidingDelegationConnectorImpl
