/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourceconfiguration.impl;

import edu.kit.ipd.descartes.mm.resourceconfiguration.PassiveResourceCapacity;
import edu.kit.ipd.descartes.mm.resourceconfiguration.PassiveResourceSpecification;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage;

import edu.kit.ipd.descartes.mm.resourcetype.PassiveResourceType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Passive Resource Specification</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.PassiveResourceSpecificationImpl#getCapacity <em>Capacity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourceconfiguration.impl.PassiveResourceSpecificationImpl#getPassiveResourceType <em>Passive Resource Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PassiveResourceSpecificationImpl extends ConfigurationSpecificationImpl implements PassiveResourceSpecification {
	/**
     * The cached value of the '{@link #getCapacity() <em>Capacity</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getCapacity()
     * @generated
     * @ordered
     */
	protected PassiveResourceCapacity capacity;

	/**
     * The cached value of the '{@link #getPassiveResourceType() <em>Passive Resource Type</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getPassiveResourceType()
     * @generated
     * @ordered
     */
	protected PassiveResourceType passiveResourceType;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected PassiveResourceSpecificationImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return ResourceconfigurationPackage.Literals.PASSIVE_RESOURCE_SPECIFICATION;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public PassiveResourceCapacity getCapacity() {
        return capacity;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetCapacity(PassiveResourceCapacity newCapacity, NotificationChain msgs) {
        PassiveResourceCapacity oldCapacity = capacity;
        capacity = newCapacity;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY, oldCapacity, newCapacity);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setCapacity(PassiveResourceCapacity newCapacity) {
        if (newCapacity != capacity) {
            NotificationChain msgs = null;
            if (capacity != null)
                msgs = ((InternalEObject)capacity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY, null, msgs);
            if (newCapacity != null)
                msgs = ((InternalEObject)newCapacity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY, null, msgs);
            msgs = basicSetCapacity(newCapacity, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY, newCapacity, newCapacity));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public PassiveResourceType getPassiveResourceType() {
        if (passiveResourceType != null && passiveResourceType.eIsProxy()) {
            InternalEObject oldPassiveResourceType = (InternalEObject)passiveResourceType;
            passiveResourceType = (PassiveResourceType)eResolveProxy(oldPassiveResourceType);
            if (passiveResourceType != oldPassiveResourceType) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__PASSIVE_RESOURCE_TYPE, oldPassiveResourceType, passiveResourceType));
            }
        }
        return passiveResourceType;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public PassiveResourceType basicGetPassiveResourceType() {
        return passiveResourceType;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setPassiveResourceType(PassiveResourceType newPassiveResourceType) {
        PassiveResourceType oldPassiveResourceType = passiveResourceType;
        passiveResourceType = newPassiveResourceType;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__PASSIVE_RESOURCE_TYPE, oldPassiveResourceType, passiveResourceType));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY:
                return basicSetCapacity(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY:
                return getCapacity();
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__PASSIVE_RESOURCE_TYPE:
                if (resolve) return getPassiveResourceType();
                return basicGetPassiveResourceType();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY:
                setCapacity((PassiveResourceCapacity)newValue);
                return;
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__PASSIVE_RESOURCE_TYPE:
                setPassiveResourceType((PassiveResourceType)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY:
                setCapacity((PassiveResourceCapacity)null);
                return;
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__PASSIVE_RESOURCE_TYPE:
                setPassiveResourceType((PassiveResourceType)null);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__CAPACITY:
                return capacity != null;
            case ResourceconfigurationPackage.PASSIVE_RESOURCE_SPECIFICATION__PASSIVE_RESOURCE_TYPE:
                return passiveResourceType != null;
        }
        return super.eIsSet(featureID);
    }

} //PassiveResourceSpecificationImpl
